﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using BindingTest.Data;
using Infragistics.Controls.Grids;
using Infragistics;
using Infragistics.Silverlight.Chart;

namespace BindingTest
{
    public partial class MainPage : UserControl
    {
        DataTable table;

        public MainPage()
        {
            InitializeComponent();

            comboBox1.SelectedIndex = 0;
        }

        private void comboBox1_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            Random r = new Random();
            table = new DataTable();

            table.Columns.Add(new DataColumn() { ColumnName = "ID", DataType = typeof(int) });
            table.Columns.Add(new DataColumn() { ColumnName = "Name", DataType = typeof(string) });
            table.Columns.Add(new DataColumn() { ColumnName = "UnitPrice", DataType = typeof(double) });
            table.Columns.Add(new DataColumn() { ColumnName = "Date", DataType = typeof(DateTime) });
            table.Columns.Add(new DataColumn() { ColumnName = "Discontinued", DataType = typeof(int) });
            //if(comboBox1.SelectedIndex == 2)
            //    table.Columns.Add(new DataColumn() { ColumnName = "NewColumn", DataType = typeof(decimal) });
            //if (comboBox1.SelectedIndex == 1)
            //    table.Columns.Add(new DataColumn() { ColumnName = "NewerColumn", DataType = typeof(int) });

            for (var i = 0; i < 20; i++)
            {
                DataRow row = new DataRow();
                row["ID"] = i;
                row["Name"] = "Name"+i;
                row["UnitPrice"] = Convert.ToDouble(r.Next(100));
                row["Date"] = DateTime.Now.AddDays(i);
                row["Discontinued"] = r.Next(2);
                //if(comboBox1.SelectedIndex == 2)
                //    row["NewColumn"] = Convert.ToDecimal(r.Next(20));
                //if (comboBox1.SelectedIndex == 1)
                //    row["NewerColumn"] = r.Next(200);

                table.Rows.Add(row);
            }

            xamGrid1.ItemsSource = null;
            xamGrid1.ItemsSource = table;

            xamWebChart1.Series.Clear();

            Infragistics.Silverlight.Chart.Animation ani = new Infragistics.Silverlight.Chart.Animation();
            ani.BeginTime = TimeSpan.FromSeconds(0.5);
            ani.Duration = TimeSpan.FromSeconds(2.5);
            ani.Sequential = true;

            Series seriesChart = new Series();
            seriesChart.ChartType = ChartType.Column;
            seriesChart.Animation = ani;
            seriesChart.DataSource = table;
            seriesChart.DataPointColor = DataPointColor.Different;
            seriesChart.Label = "Name";
            seriesChart.DataMapping = "Value=UnitPrice";

            Marker mark = new Marker();
            mark.Type = MarkerType.Circle;
            mark.Fill = new SolidColorBrush(Colors.Red);
            seriesChart.Marker = mark;
            
            xamWebChart1.Series.Add(seriesChart);           
        }

        private void xamGrid1_Loaded(object sender, RoutedEventArgs e)
        {
            //Row rw = xamGrid1.Rows[0];
            this.Dispatcher.BeginInvoke(() =>
            {
                foreach (DataColumn col in table.Columns)
                {
                    if (col.DataType == typeof(Int32))
                    {
                        TextColumn c = (TextColumn)xamGrid1.Columns[col.ColumnName];
                        if (c != null)
                        {
                            c.HorizontalContentAlignment = System.Windows.HorizontalAlignment.Right;

                            foreach (SummaryOperandBase operand in c.SummaryColumnSettings.SummaryOperands)
                            {
                                if (operand is SumSummaryOperand)
                                    operand.IsApplied = true;
                            }

                            LessThanConditionalFormatRule less = new LessThanConditionalFormatRule();
                            less.Value = 20;
                            less.StyleToApply = Resources["NegativeValue"] as Style;
                            c.ConditionalFormatCollection.Add(less);
                        }
                    }
                }
            });
        }
    }
}
